/*
 * PIMPPA - Create all assign patterns
 *
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <ctype.h>
#include <unistd.h>

#include "pimppa.h"

int ClearPrevious=0;					// Clear previous assign patterns?

int create_assigns(void)
{
	MYSQL src_db;
	MYSQL dst_db;
	MYSQL_RES *sql_res;
	MYSQL_ROW sql_row;
	unsigned long total_files=0;

/********* Connect databases ****************/

	if(!p_connect(&src_db))
		return(0);

	if(!p_connect(&dst_db))
	{
		mysql_close(&src_db);
		return(0);
	}

/******** Delete previous patterns? ********/

	if(ClearPrevious)
	{
		fprintf(stderr, "Clearing previous assign patterns...\n");
		p_query(&dst_db, "DELETE FROM p_assign WHERE a_dest>=0");
	}
		
/******** check and assign *******/

	fprintf(stderr, "Processing filenames...\n");

	p_query(&src_db, "SELECT file_name, file_area
					FROM p_files, p_areas
					WHERE NOT (area_flags & %ld) AND area_id=file_area
					AND NOT (file_backup=0 AND (file_flags & %ld))",
					AREA_INCOMING, FILE_OFFLINE);
	if(mysql_error(&src_db)[0])
		return(-1);
	sql_res=mysql_use_result(&src_db);

	while((sql_row=mysql_fetch_row(sql_res)))
	{
		char pattern[P_LEN_FILE_NAME];

		if(p_makepattern(pattern, sql_row[0])>=P_MIN_ASS_NAMELENGTH)
		{
			char escaped_pat[2*P_LEN_FILE_NAME+1];
		
			mysql_escape_string(escaped_pat, pattern, strlen(pattern));
		
			p_query(&dst_db, "REPLACE INTO p_assign (a_pattern, a_dest)
							VALUES ('%s', %s)", 
							escaped_pat, sql_row[1]);
		
			total_files++;
		}
		if(total_files%500==0)
			fprintf(stderr, "%ld done...\n", total_files);
	}

	mysql_free_result(sql_res);
	
	mysql_close(&src_db);
	mysql_close(&dst_db);
	return(total_files);
}
	

int main(int argc, char *argv[])
{
	int assigns;
	int go=1;

	while(go)
	{
		switch(getopt(argc, argv, "chV"))
		{
			case 'c':
				ClearPrevious=1;
				break;
			case 'h':
				printf("Usage: %s <options>\n\n", argv[0]);
				printf("-c     Clear all previous assigns. Does not affect\n");
				printf("       patterns with negative destination area.\n");
				return(0);
				break;
			case 'V':
				printf("%s %s %s\n", PACKAGE, argv[0], VERSION);
				return(0);
				break;
			default:
				go=0;
				break;
		}
	}	

	assigns=create_assigns();

	fprintf(stderr, "Done, %d patterns created...\n", assigns);
		
	return(0);
}

